import connection.Connection;
import connection.IConnection;
import push_back_connection.IPushBackConnection;
import push_back_connection.PushBackConnection;
import resumable_connection.ResumableConnection;

import java.io.IOException;

public class Tester {
    public static void TestIConnection(IConnection c) {
        System.out.println("--------- Testing IConnection ---------");
        connect(c);
        send(c, 10);
        disconnect(c);
        send(c, 20);

        connect(c);
        receive(c);
        disconnect(c);
        receive(c);

        connect(c);
        receive(c);
        receive(c);
        receive(c);
    }

    public static void TestIPushBackConnection(IPushBackConnection c) {
        TestIConnection(c);
        System.out.println("--------- Testing IPushBackConnection ---------");
        pushBack(c, 10);
        connect(c);
        pushBack(c, 11);
        connect(c);
        receive(c);
        receive(c);
        disconnect(c);
        receive(c);
    }

    public static void main(String[] args) {
        System.out.println("========= Testing Connection =========");
        TestIConnection(Connection.createAutomaton());
        System.out.println("========= Testing PushBackConnection =========");
        TestIPushBackConnection(PushBackConnection.createAutomaton());
        System.out.println("========= Testing ResumableConnection =========");
        TestIConnection(ResumableConnection.createAutomaton());
    }

    public static void connect(IConnection connection) {
        try {
            System.out.print("Connecting... ");
            connection.connect();
            System.out.println(" OK");
        } catch (IOException e) {
            System.out.println(" error");
        }
    }

    public static void disconnect(IConnection connection) {
        try {
            System.out.print("Disconnecting... ");
            connection.disconnect();
            System.out.println(" OK");
        } catch (IOException e) {
            System.out.println(" error");
        }
    }

    public static void receive(IConnection connection) {
        try {
            System.out.print("Receiving... ");
            System.out.println(" " + connection.receive() + " received");
        } catch (IOException e) {
            System.out.println(" error");
        }
    }

    public static void send(IConnection connection, int value) {
        try {
            System.out.print("Sending (" + value + ")... ");
            connection.send(value);
            System.out.println(" OK");
        } catch (IOException e) {
            System.out.println(" error");
        }
    }

    public static void pushBack(IPushBackConnection connection, int value) {
        try {
            System.out.print("Pushing back (" + value + ")...");
            connection.pushBack(value);
            System.out.println(" OK");
        } catch (IOException e) {
            System.out.println(" error");
        }
    }
}