package connection;

import ru.ifmo.is.sm.*;
import java.io.IOException;

public class ConnectedState <AI extends IConnection>
		extends StateBase<AI> implements IConnection {
	public static final Event DISCONNECT = new Event("DISCONNECT");
	public static final Event ERROR = new Event("ERROR");

	protected final Socket socket;

	public ConnectedState(AI automaton, IEventSink eventSink, Socket socket) {
		super(automaton, eventSink);
		this.socket = socket;
	}

	public void connect() throws IOException {
	}

	public void disconnect() throws IOException {
		try {
			socket.disconnect();
		} finally {
			eventSink.castEvent(DISCONNECT);
		}
	}

	public int receive() throws IOException {
		try {
			return socket.receive();
		} catch (IOException e) {
			eventSink.castEvent(ERROR);
			throw e;
		}
	}

	public void send(int value) throws IOException {
		try {
			socket.send(value);
		} catch (IOException e) {
			eventSink.castEvent(ERROR);
			throw e;
		}
	}
}
