package connection;

import java.io.IOException;
import ru.ifmo.is.sm.AutomatonBase;

public class Connection extends AutomatonBase<IConnection>
		implements IConnection {
	private Connection() {
		Socket socket = new Socket();

		//   
		IConnection connected = new ConnectedState<Connection>(this, this, socket);
		IConnection disconnected = new DisconnectedState<Connection>(this, this, socket);

		//  
		addEdge(connected, ConnectedState.DISCONNECT, disconnected);
		addEdge(connected, ConnectedState.ERROR, disconnected);
		addEdge(disconnected, DisconnectedState.CONNECT, connected);
		addEdge(disconnected, DisconnectedState.ERROR, disconnected);

		//  
		state = disconnected;
	}

	//   
	public static IConnection createAutomaton() {
		return new Connection();
	}

	//   
	public void connect() throws IOException { state.connect(); }
	public void disconnect() throws IOException { state.disconnect(); }
	public int receive() throws IOException { return state.receive(); }
	public void send(int value) throws IOException { state.send(value); }
}