package connection;

import java.io.IOException;
import ru.ifmo.is.sm.*;

public class DisconnectedState <AI extends IConnection>
		extends StateBase<AI> implements IConnection {
	public static final Event CONNECT = new Event("CONNECT");
	public static final Event ERROR = new Event("ERROR");

	protected final Socket socket;

	public DisconnectedState(AI automaton, IEventSink eventSink, Socket socket) {
		super(automaton, eventSink);
		this.socket = socket;
	}

	public void connect() throws IOException {
		try {
			socket.connect();
			eventSink.castEvent(CONNECT);
		} catch (IOException e) {
			eventSink.castEvent(ERROR);
			throw e;
		}
	}

	public void disconnect() throws IOException {
	}

	public int receive() throws IOException {
		throw new IOException("Connection is closed (receive)");
	}

	public void send(int value) throws IOException {
		throw new IOException("Connection is closed (send)");
	}
}
