package push_back_connection;

import connection.*;
import ru.ifmo.is.sm.IEventSink;
import java.util.Stack;
import java.io.IOException;

public class PushBackConnectedState <AI extends IPushBackConnection>
		extends ConnectedState<AI> implements IPushBackConnection {
	Stack<Integer> stack = new Stack<Integer>();

	public PushBackConnectedState(AI automaton, IEventSink eventSink, Socket socket) {
		super(automaton, eventSink, socket);
	}

	public int receive() throws IOException {
		if (stack.empty()) {
			return super.receive();
		}

		return stack.pop().intValue();
	}

	public void pushBack(int value) {
		stack.push(new Integer(value));
	}
}
