package push_back_connection;

import connection.Socket;
import ru.ifmo.is.sm.AutomatonBase;
import java.io.IOException;

public class PushBackConnection extends AutomatonBase<IPushBackConnection>
		implements IPushBackConnection {
	private PushBackConnection() {
		Socket socket = new Socket();

		//   
		IPushBackConnection connected = new PushBackConnectedState<PushBackConnection>(this, this, socket);
		IPushBackConnection disconnected = new PushBackDisconnectedState<PushBackConnection>(this, this, socket);

		//  
		addEdge(connected, PushBackConnectedState.DISCONNECT, disconnected);
		addEdge(connected, PushBackConnectedState.ERROR, disconnected);
		addEdge(disconnected, PushBackDisconnectedState.CONNECT, connected);

		//  
		state = disconnected;
	}

	//   
	public static IPushBackConnection createAutomaton() {
		return new PushBackConnection();
	}

	//   
	public void connect() throws IOException { state.connect(); }
	public void disconnect() throws IOException { state.disconnect(); }
	public int receive() throws IOException { return state.receive(); }
	public void send(int value) throws IOException { state.send(value); }
	public void pushBack(int value) throws IOException { state.pushBack(value); }
}
