package resumable_connection;

import connection.*;
import ru.ifmo.is.sm.*;
import java.io.IOException;

public class ErrorState <AI extends IConnection>
		extends StateBase<AI> implements IConnection {
	public static final Event CONNECT = new Event("CONNECT");
	public static final Event DISCONNECT = new Event("DISCONNECT");

	protected final Socket socket;

	public ErrorState(AI automata, IEventSink eventSink, Socket socket) {
		super(automata, eventSink);
		this.socket = socket;
	}

	public void connect() throws IOException {
		socket.connect();
		castEvent(CONNECT);
	}

	public void disconnect() throws IOException {
		castEvent(DISCONNECT);
	}

	public int receive() throws IOException {
		connect();
		return automaton.receive();
	}

	public void send(int value) throws IOException {
		connect();
		automaton.send(value);
	}
}
