package ru.ifmo.is.sm;

import java.util.IdentityHashMap;
import java.util.Map;
import java.util.HashMap;

public abstract class AutomatonBase<AI> implements IEventSink {
	protected AI state;
	private final Map<AI, Map<Event, AI>> edges =
			new HashMap<AI, Map<Event, AI>>();

	protected void addEdge(AI source, Event event, AI target) {
		Map<Event, AI> row = edges.get(source);
		if (null == row) {
			row = new IdentityHashMap<Event, AI>();
			edges.put(source, row);
		}
		row.put(event, target);
	}

	public void castEvent(Event event) {
		try {
			state = edges.get(state).get(event);
		} catch (NullPointerException e) {
			throw new IllegalStateException("Edge is not defined");
		}
	}
}
