package ru.ifmo.is.sm;

public abstract class StateBase<AI> {
	protected final AI automaton;
	protected final IEventSink eventSink;

	public StateBase(AI automaton, IEventSink eventSink) {
		if (automaton == null || eventSink == null) {
			throw new NullPointerException();
		}
		this.automaton = automaton;
		this.eventSink = eventSink;
	}

	protected void castEvent(Event event) {
		eventSink.castEvent(event);
	}
}